#ifndef _KALMAN_HPP_
#define _KALMAN_HPP_

/****************************************************************/
/*  File: kalman.hpp                                              */
/*  Sistemas de Vision Computacional Trabajo Final              */		
/*  Fichero basico de cabecera para filtro de Kalman            */
/****************************************************************/



#define SIGMA_R 0.5 // measurement noise cov
#define SIGMA_Q 0.1 // state noise cov
#define SIGMA_P 0.1 // error cov
#define STATE_SIZE 8
#define MEAS_SIZE 4

using namespace std;
using namespace cv;

// State struct
typedef struct kfState8_t
{
  // 2D position
  float x;
  float y;
  // ROI size
  float w;
  float h;
  // 2D velocity
  float vx;
  float vy;
  // size change velocity
  float vw;
  float vh;
} kfState8_t;

// Measurement struct
typedef struct kfMeas4_t
{
  // 2D position
  float x;
  float y;
  // ROI size
  float w;
  float h;
} kfMeas4_t;


class blobs_t
{

    KalmanFilter kf;
    kfState8_t initState;
    kfMeas4_t measurement;    
    
    unsigned int lifeTime;
    int lostN;
      
}; 


KalmanFilter initKalman(const kfState8_t init_state);

//update the KF with the measurement
void updateKalman(KalmanFilter& kalf, kfMeas4_t meas);

//update the KF with the prediction
void updateKalman(KalmanFilter& kalf);

#endif
