
#include <cv.h>
#include <highgui.h>

using namespace std;
using namespace cv;


int main( int argc, char** argv )
{
    
    Mat newImg, grayImg, contourImg;
    vector<vector<Point> > contours;
    
    namedWindow("SRC");
    namedWindow("Edges");
    namedWindow("Contours");
 
    newImg = imread(argc >= 2 ? argv[1] : "fruits.jpg", 1); 
    
    imshow("SRC", newImg);
    
    cvtColor(newImg, grayImg, CV_BGR2GRAY);
    
    Canny(grayImg, grayImg, 100, 150, 3);
    imshow("Edges", grayImg);
    
    contourImg = newImg.clone();
    
    findContours(grayImg, contours, CV_RETR_CCOMP, CV_CHAIN_APPROX_SIMPLE);
    drawContours(contourImg, contours, -1, CV_RGB(0, 255, 0));
    
    imshow("Contours", contourImg);
    
    waitKey(0);
    
    return 0;
} 
