
#include <cv.h>
#include <highgui.h>

using namespace std;
using namespace cv;


int main( int argc, char** argv )
{

    Mat src, gray, grayThresh;

    src = imread(argc >= 2 ? argv[1] : "fruits.jpg", 1); 
    // 0 => read as grayscale, '>0'=>read as color, 
    //'<0'=>read as-is
    
    // gray.create(src.size(), CV_8U);

    namedWindow("src", CV_WINDOW_AUTOSIZE);//create windows
    namedWindow("gray", CV_WINDOW_AUTOSIZE);
    namedWindow("grayThreshold", CV_WINDOW_AUTOSIZE);
  
    cvtColor(src, gray, CV_BGR2GRAY); //color images are BGR by default!

    threshold(gray, grayThresh, 100, 250, CV_THRESH_BINARY);

    imshow("src", src);
    imshow("gray", gray);
    imshow("grayThreshold", grayThresh);

    waitKey(0); //waits for a key: it also controls the GUI
		//events. You have to call it regularly for images to
		//show properly

    //   destroyWindow("src");
    
    
    return 0; //no need to free the matrices, they are deleted automatically
}
